import { IMouseEvent } from "@codingame/monaco-vscode-api/vscode/vs/base/browser/mouseEvent";
import { ContentWidgetPositionPreference, ICodeEditor, IContentWidget, IContentWidgetPosition } from "@codingame/monaco-vscode-api/vscode/vs/editor/browser/editorBrowser";
import { IDimension } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/core/dimension";
import { Position } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/core/position";
import { IMenuService } from "@codingame/monaco-vscode-api/vscode/vs/platform/actions/common/actions.service";
import { IContextKeyService } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextkey/common/contextkey.service";
import { IContextMenuService } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextview/browser/contextView.service";
import { IInstantiationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/instantiation/common/instantiation";
import { IExpression, IStackFrame } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug";
import { IDebugService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug.service";
export declare enum ShowDebugHoverResult {
    NOT_CHANGED = 0,
    NOT_AVAILABLE = 1,
    CANCELLED = 2
}
export declare function findExpressionInStackFrame(stackFrame: IStackFrame, namesToFind: string[]): Promise<IExpression | undefined>;
export declare class DebugHoverWidget implements IContentWidget {
    private editor;
    private readonly debugService;
    private readonly instantiationService;
    private readonly menuService;
    private readonly contextKeyService;
    private readonly contextMenuService;
    static readonly ID = "debug.hoverWidget";
    readonly allowEditorOverflow = true;
    private _isVisible?;
    private safeTriangle?;
    private showCancellationSource?;
    private domNode;
    private tree;
    private showAtPosition;
    private positionPreference;
    private readonly highlightDecorations;
    private complexValueContainer;
    private complexValueTitle;
    private valueContainer;
    private treeContainer;
    private toDispose;
    private scrollbar;
    private debugHoverComputer;
    private expressionRenderer;
    private expressionToRender;
    private isUpdatingTree;
    get isShowingComplexValue(): boolean;
    constructor(editor: ICodeEditor, debugService: IDebugService, instantiationService: IInstantiationService, menuService: IMenuService, contextKeyService: IContextKeyService, contextMenuService: IContextMenuService);
    private create;
    private onContextMenu;
    private registerListeners;
    isHovered(): boolean;
    isVisible(): boolean;
    willBeVisible(): boolean;
    getId(): string;
    getDomNode(): HTMLElement;
    isInSafeTriangle(x: number, y: number): boolean | undefined;
    showAt(position: Position, focus: boolean, mouseEvent?: IMouseEvent): Promise<void | ShowDebugHoverResult>;
    private static readonly _HOVER_HIGHLIGHT_DECORATION_OPTIONS;
    private doShow;
    private layoutTreeAndContainer;
    private layoutTree;
    beforeRender(): IDimension | null;
    afterRender(positionPreference: ContentWidgetPositionPreference | null): void;
    hide(): void;
    getPosition(): IContentWidgetPosition | null;
    dispose(): void;
}
